/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/
var msec=0;
var sec=10;
var min=1;
var hou = 0;
var msec2=0;
var min2=0;
var sec2=0;
var hou2=0;

var wsec=10;
var wmin=0;
var whou = 0;
var wmsec2=0;
var wmin2=0;
var wsec2=0;
var whou2=0;


var waitfor = 0;
var isrunning=false;
var isfinished=false;
var isPaused = false;
var isWaiting = false;
var firsttime = true;
var cancelled = false;
var rotatingWheelDiameter = 20
var rotatingWheelDiameterDiv = rotatingWheelDiameter/2
var currentRotatingWheelAngle = 0;
var rotatingWheelTimer;
var rotatingWheelCanvas;
var rotatingWheelContext;
var rotatingWheelImage;
var mathpi = Math.PI/10;
//var waitit = null;
function sessionButtonClicked(){
	//widget.system("~/Library/Widgets/countdown.wdgt/play ~/Library/Widgets/countdown.wdgt/widget_bell.mp3",null);
	//document.getElementById('meditationtimertext').innerText=widget.system("/usr/bin/which which",null).outputString;
	
	if (isWaiting){
		
		isWaiting = false;
		var button = document.getElementById('beginButton');
		button.src = 'Images/begin.png';
		clearTimeout(waitit);
		isfinished=true;
		cancelled = true;
		stop();
		
		//stopRotatingWheel();
		//isrunning = false;
		//firsttime=true;
		//isfinished = true;
		//
		return;
	}
	if (!isrunning){
		if (window.widget && !isfinished){
			if (firsttime) {
				isrunning=true;
				firsttime=false;
				waitTimer();
				
				
			}
			
			if(!isPaused){
				var hour = widget.preferenceForKey('hour');
				var minute = widget.preferenceForKey('minute');
				var	 second = widget.preferenceForKey("second");
				var waittime = widget.preferenceForKey('waittime');
				if (hour && hour.length > 0){
					hou = hour; 
				}
				if (minute && minute.length > 0){
					min = minute; 
				}
				if (second && second.length > 0){
					sec = second; 
				}
			}
			isPaused = false;
		
		}
		
		//if (wheelStatus) wheelStatus.fadeOut();
		startRotatingWheel();
		start();
	
	}else{
		pauseTimer();
		isPaused=true;
	
	}

	
	
}
function waitTimer(){
	var waittime = widget.preferenceForKey('waittime');
	
	if (waittime && waittime.length > 0){
		waitfor = waittime*60;
		var button = document.getElementById('beginButton');
		button.src = 'Images/cancel.png';
		isWaiting = true;
		whou = 0;
		wmin = waittime;
		wsec = 0
		changeTime(whou,wmin,wsec);
		waitnow();
		
		
				
	}else{
		isWaiting = false;
		widget.system("./play widget_bell.mp3",done);			
	}
}
function waitnow(){
	waitfor--;
	
	//document.getElementById('meditationtimertext').innerText=waitfor;
	waitit=setTimeout("waitnow()",1000);
	
	
	
	
	if (waitfor < 0){
		widget.system("./play widget_bell.mp3",done);			
		isWaiting = false;
		clearTimeout(waitit);
	}
	wsec--;
	if (wsec < 0){
		wsec = 59;
		wmin--;
		if (wmin < 0){
			wmin = 59;
			whou--;
		}
	}
	changeTime(whou,wmin,wsec);
		
}
	
function pauseTimer(){
	var statusObj = document.getElementById('wheel_status');
	var button = document.getElementById('beginButton');
	button.src = 'Images/resume.png';
	stop();
	isrunning=false;
	statusObj.style.backgroundImage = 'url(Images/status_pause.png)';
	//if (wheelStatus) wheelStatus.fadeIn();
}
function start()
{
	if (!isWaiting){
		var button = document.getElementById('beginButton');
		button.src = 'Images/pause.png';
	}
	go=setTimeout("start()",100)
	if (waitfor > 0){
		return;
	}
	isrunning=true;
	isfinished=false;
	min2=min;
	msec2=msec;
	sec2=sec;
	hou2 = hou;
	if (min < 10){
		min2 = "0"+min;
	}
	if (sec < 10){
		sec2 = "0"+sec;
	}
	if (hou < 10){
		hou2 = "0"+hou;
	}
	
	
	
	
	msec++
	if(msec==10)
	{
		msec=0
		sec--
	}
	if(sec < 0)
	{
		if (hou == 0 && min == 0 && sec <= 0){
			isfinished=true;
			stop();
			return;
		}
		
		sec=59
		min--
	}
	if(min < 0 && hou > 0 )
	{
		min=59
		sec=59;
		hou--
	}
	//document.getElementById('display').innerText=hou2+":"+min2+":"+sec2;
	changeTime(hou,min,sec);
	
}
function changeTime(hou,min,sec){
	//document.getElementById('display').innerText="t."+hou+":"+min+":"+sec;
	number1 =  Math.floor(sec/10);
	number2 = sec %10;
	var secimage1 = number1+".png";
	var secimage2 = number2+".png";
	//document.getElementById('display').innerText = secimage2;
	
	var button = document.getElementById('S1');
	button.src = 'Images/'+secimage1;
	button = document.getElementById('S2');
	button.src = 'Images/'+secimage2;
	
	number1 =  Math.floor(min/10);
	number2 = min %10;
	var minimage1 = number1+".png";
	var minimage2 = number2+".png";
	button = document.getElementById('M1');
	button.src = 'Images/'+minimage1;
	button = document.getElementById('M2');
	button.src = 'Images/'+minimage2;
	
	number1 = Math.floor(hou / 10);
	number2 = hou%10;
	
	var hourimage1 = number1+".png";
	var hourimage2 = number2+".png";
	
	button = document.getElementById('H1');
	button.src = 'Images/'+hourimage1;
	button = document.getElementById('H2');
	button.src = 'Images/'+hourimage2;
	
	return;
	
}
function stop()
{
	clearTimeout(go);
	//var thissound=document.getElementById('sound1');
  	//	thissound.Play();
  	stopRotatingWheel();
	if(isfinished){
		//document.getElementById('display').innerText="00:00:00";
		changeTime(0,0,0);
		var button = document.getElementById('beginButton');
		button.src = 'Images/begin.png';
		if (!cancelled) {
			widget.system("./play widget_bell.mp3",done);
		}
		cancelled = false;
		isrunning=false;
		isfinished=false;
		isPaused = false;
		firsttime = true;


	}
	
}

function reset_timer()
{
	isfinished=true;
	cancelled = true;
	stop();
	document.foo.reset();
}




// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

function setup()
{
	//widget.system("open *.TTF",null);
	if (window.widget){
			
			wheelStatus = new Fader(document.getElementById('wheel_status'), null, 1/3*1000);
			wheelIcon = new Fader(document.getElementById('rotatingWheelCanvas'), null, 1/3*1000);
			rotatingWheelCanvas = document.getElementById('rotatingWheelCanvas');
			rotatingWheelContext = rotatingWheelCanvas.getContext('2d');
			rotatingWheelImage = new Image();
			rotatingWheelImage.src = 'Images/RotatingWheel.png';
			
			rotatingWheelImage.onload = rotatingWheelImage.onerror = rotatingWheelImage.onabort = function() { updateRotatingWheel(false) }
			
			var hour = widget.preferenceForKey('hour');
			var minute = widget.preferenceForKey('minute');
			var second = widget.preferenceForKey("second");
			var waittime = widget.preferenceForKey('waittime');
			if (hour && hour.length > 0){
				hou = hour; 
			}
			if (minute && minute.length > 0){
				min = minute; 
			}
			if (second && second.length > 0){
				sec = second; 
			}
			
		
	
			var hour = widget.preferenceForKey('hour');
			var minute = widget.preferenceForKey('minute');
			var second = widget.preferenceForKey("second");
			var waittime = widget.preferenceForKey('waittime');
			if (hour && hour.length > 0){
				hou = hour; 
			}
			if (minute && minute.length > 0){
				min = minute; 
			}
			if (second && second.length > 0){
				sec = second; 
			}
		
			
		
	}
}
function done()
{
	
}

function startRotatingWheel()
{
	if (!rotatingWheelTimer)
	{
		var wheelObj = document.getElementById('rotatingWheelCanvas');
		wheelObj.style.visibility = 'visible';
		if (wheelIcon) wheelIcon.fadeIn();
		rotatingWheelTimer = setInterval('updateRotatingWheel()', 1/15*1000);
	}
}

function stopRotatingWheel()
{
	if (rotatingWheelTimer)
	{
		//if (wheelIcon) wheelIcon.fadeOut();
		clearInterval(rotatingWheelTimer);
		rotatingWheelTimer = null;
	}
}

function updateRotatingWheel()
{
	currentRotatingWheelAngle += mathpi;
	rotatingWheelContext.clearRect(0, 0, rotatingWheelDiameter, rotatingWheelDiameter);
	rotatingWheelContext.save();
	rotatingWheelContext.translate(rotatingWheelDiameterDiv, rotatingWheelDiameterDiv);
	rotatingWheelContext.rotate(currentRotatingWheelAngle);
	rotatingWheelContext.translate(-rotatingWheelDiameterDiv, -rotatingWheelDiameterDiv);
	rotatingWheelContext.drawImage(rotatingWheelImage, 0, 0, rotatingWheelDiameter, rotatingWheelDiameter);
	rotatingWheelContext.restore();
}

function goToMeditationResources(event)
{
	if (window.widget)
	{
		widget.openURL("http://www.meditationresources.com");
	}
}


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showBack()

{

    var front = document.getElementById("front");

    var back = document.getElementById("back");



    if (window.widget)

        widget.prepareForTransition("ToBack");



    front.style.display="none";

    back.style.display="block";



    if (window.widget)

        setTimeout ('widget.performTransition();', 0);  

}
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (isrunning) {
		pauseTimer();
		isPaused=true;
	}
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget)
	{
		var hourObj = document.getElementById("inputTimerTextH"); 
		var minuteObj = document.getElementById("inputTimerTextM"); 
		var secondObj = document.getElementById("inputTimerTextS"); 
		var waitObj = document.getElementById("minutesPopup"); 
		if (hourObj != null)
			widget.setPreferenceForKey(hourObj.value,'hour');
		if (minuteObj != null)	
			widget.setPreferenceForKey(minuteObj.value,'minute');
		if (secondObj != null)
			widget.setPreferenceForKey(secondObj.value,'second');	
		if (waitObj != null)	
			widget.setPreferenceForKey(waitObj.value,'waittime');	
		
		
	}
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	var statusObj = document.getElementById('wheel_status');
	if (wheelIcon) wheelIcon.fadeOut();
	statusObj.style.backgroundImage = 'url(Images/status_pause.png)';
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

